#ifndef _CHANNEL_HOOK_GENERAL_H_
#define _CHANNEL_HOOK_GENERAL_H_

#include <stack>

#define MAX_NET_COMPUTER_NAME	16

struct SNodeInfo
{
    DWORD process_id;				//PID of the process
    CHAR computer_name[MAX_NET_COMPUTER_NAME];	//network name of the computer
    HANDLE user_token;				//security token of the calling user
};

class CCallContext
{
    public:
	CCallContext();
	~CCallContext();

	SNodeInfo* get_node_info();
	void clear();

	void fill_user_token_info();
	void convert_user_token_to_local_process();

    private:
	SNodeInfo node_info;
	bool b_local_token;
};

typedef std::stack<CCallContext*> CCallContextStack;

class CThreadContext
{
    public:
	CThreadContext(){};
	~CThreadContext();

	CCallContext* GetLastReceivedCall();

	CCallContextStack sent_client_info;
	CCallContextStack recieved_client_info;
};

extern const IID CHANNEL_HOOK_ID;

#endif
